---
id: learning-resources
title: Learning Resources
sidebar_label: Learning Resources
hide_title: true
---

# Learning Resources

The Redux docs are intended to teach the basic concepts of Redux, as well as explain key concepts
for use in real-world applications. Here are a few recommended outside resources.

As ReduxKotlin.org is new, and Kotlin Multiplatform as well, there are not a lot of resources directly on the subject.  Most articles on Redux for mobile will apply, even if the article references a different redux library.  Keep in mind if you are targeting multiple platforms, then some articles may no be applicable.

This page includes our recommendations for some of the best external resources available to learn
Redux. For an additional extensive list of tutorials, articles, and other resources on React, Redux,
Javascript, and related topics, see the
[React/Redux Links list](https://github.com/markerikson/react-redux-links).

## Introductions
- **ReduxKotlin.org: Redux for All Kotlin Platforms**  
  [Video on Droidcon.com](https://www.droidcon.com/media-detail?video=362742403)  
  [Slides available here](https://www.slideshare.net/PatrickJackson14/reduxkotlinorg-droidcon-nyc-2019?from_m_app=android)  
  Talk by Patrick Jackson at Droidcon NYC overviewing ReduxKotlin.org and showing an approach to MPP Kotlin apps using redux.
   
- **The Journey of Android Engineers: Reduxing UI Bugs by Christina Lee**  
  [Youtube video](https://www.youtube.com/watch?v=UsuzhTlccRk)  
  In this lightning talk, Christina covers how the engineers at Highlight built a Redux-like framework in Kotlin to simplify state management and reduce bugs in challenging UI components, all without having to reinvent their Android app or sacrifice hard won expertise.
  
- **Redux for Android**  
   [Video on Droidcon.com](https://www.droidcon.com/media-detail?video=362739048)  
   In this session, Elliott Chenger talks about Redux and how Redux can help simplify your architecture and your life. Are you worried that you won't be able to use any of the nice lifecycle-aware libraries Google created? Redux still works with Android Architecture components, and Elliott will explain how you can utilize Live Data and View Models in addition to other popular libraries and technologies.
    
- **Redux + (RxKotlin | RxSwift) == Awesome Native Mobile Apps — Introduction — Part 1**  
   https://android.jlelse.eu/redux-rxkotlin-rxswift-awesome-native-mobile-apps-introduction-part-1-4ea7fa3be319  
   Explanation of Redux pattern and how to use it on Android & iOS.  Uses the ReKotlin library, but much is applicable and transferable to ReduxKotlin.
 
- **Redux on Android, the nitty gritty**  
   https://www.youtube.com/watch?v=QAOyjeD3_P8  
   Exploration of Redux on android and lessons learned from using it in a production app.

- **Redux.js.org**  
   https://redux.js.org
   The original JS Redux on which ReduxKotlin is based on.  Good source of knowledge and inspiration, however, may not be of much use if you are only using on Android/iOS.
   
## Redux on iOS
- **Unidirectional Data Flow: Shrinking Massive View Controller**  
   https://academy.realm.io/posts/benji-encz-unidirectional-data-flow-swift/  
   Overview of ReSwift and the motivation for Redux in iOS. 

- **Redux in Swift Pt. 1: What, why, and how**  
    https://medium.com/newindustrialist/redux-in-swift-pt-1-what-why-and-how-b52e6fd29440
    A take on how to use Redux in Swift with ReSwift.  Mention of devtools and how to use them on iOS.  ReduxKotlin aims to provide devtools to all platforms, but not available yet. 

